!function(root, factory) {
    "object" == typeof exports && "object" == typeof module ? module.exports = factory() : "function" == typeof define && define.amd ? define([], factory) : "object" == typeof exports ? exports.akBlanket = factory() : root.akBlanket = factory();
}(this, function() {
    /******/
    return function(modules) {
        /******/
        /******/
        // The require function
        /******/
        function __webpack_require__(moduleId) {
            /******/
            /******/
            // Check if module is in cache
            /******/
            if (installedModules[moduleId]) /******/
            return installedModules[moduleId].exports;
            /******/
            /******/
            // Create a new module (and put it into the cache)
            /******/
            var module = installedModules[moduleId] = {
                /******/
                exports: {},
                /******/
                id: moduleId,
                /******/
                loaded: !1
            };
            /******/
            /******/
            // Return the exports of the module
            /******/
            /******/
            /******/
            // Execute the module function
            /******/
            /******/
            /******/
            // Flag the module as loaded
            /******/
            return modules[moduleId].call(module.exports, module, module.exports, __webpack_require__), 
            module.loaded = !0, module.exports;
        }
        // webpackBootstrap
        /******/
        // The module cache
        /******/
        var installedModules = {};
        /******/
        /******/
        // Load entry module and return exports
        /******/
        /******/
        /******/
        /******/
        // expose the modules object (__webpack_modules__)
        /******/
        /******/
        /******/
        // expose the module cache
        /******/
        /******/
        /******/
        // __webpack_public_path__
        /******/
        return __webpack_require__.m = modules, __webpack_require__.c = installedModules, 
        __webpack_require__.p = "", __webpack_require__(0);
    }([ /* 0 */
    /***/
    function(module, exports, __webpack_require__) {
        "use strict";
        function _interopRequireWildcard(obj) {
            if (obj && obj.__esModule) return obj;
            var newObj = {};
            if (null != obj) for (var key in obj) Object.prototype.hasOwnProperty.call(obj, key) && (newObj[key] = obj[key]);
            return newObj["default"] = obj, newObj;
        }
        function _interopRequireDefault(obj) {
            return obj && obj.__esModule ? obj : {
                "default": obj
            };
        }
        function handleActivation(elem) {
            return function() {
                elem.clickable && (0, _skatejs.emit)(elem, events.activate);
            };
        }
        Object.defineProperty(exports, "__esModule", {
            value: !0
        }), exports.events = void 0;
        var _defineProperty2 = __webpack_require__(3), _defineProperty3 = _interopRequireDefault(_defineProperty2), _hasOwn = Object.prototype.hasOwnProperty, _forOwn = function(object, iterator) {
            for (var prop in object) _hasOwn.call(object, prop) && iterator(object[prop], prop);
        }, _renderArbitrary = function _renderArbitrary(child) {
            var type = typeof child;
            "number" === type || "string" === type || "object" === type && child instanceof String ? _skatejs.vdom.text(child) : "function" === type && child.__jsxDOMWrapper ? child() : Array.isArray(child) ? child.forEach(_renderArbitrary) : "object" === type && "[object Object]" === String(child) && _forOwn(child, _renderArbitrary);
        }, _skatejs = __webpack_require__(22), _classnames = __webpack_require__(24), _classnames2 = _interopRequireDefault(_classnames), _shadow = __webpack_require__(25), _shadow2 = _interopRequireDefault(_shadow), _index = __webpack_require__(27), events = _interopRequireWildcard(_index);
        /**
	 * @description Create instances of the component programmatically, or using markup.
	 * @class Blanket
	 * @example @js import Blanket from 'ak-blanket';
	 * const component = new Blanket();
	 */
        exports["default"] = (0, _skatejs.define)("ak-blanket", {
            render: function(elem) {
                var classes = (0, _classnames2["default"])([ _shadow2["default"].locals.blanket, (0, 
                _defineProperty3["default"])({}, "" + _shadow2["default"].locals.tinted, elem.tinted) ]);
                // TODO make sure that the div onclick is accessible
                return _skatejs.vdom.elementOpen("div"), _skatejs.vdom.elementOpen("style"), _renderArbitrary(_shadow2["default"].toString()), 
                _skatejs.vdom.elementClose("style"), _skatejs.vdom.elementVoid("div", null, null, "onClick", handleActivation(elem), "onTouch", handleActivation(elem), "className", classes), 
                _skatejs.vdom.elementClose("div");
            },
            props: {
                /**
	     * @description Is blanket grey with opacity or transparent. By default it's transparent.
	     * @memberof Blanket
	     * @instance
	     * @type Boolean
	     * @default false
	     * @example @html <ak-blanket tinted></ak-blanket>
	     * @example @js component.tinted = true
	     */
                tinted: _skatejs.prop["boolean"]({
                    attribute: !0
                }),
                /**
	     * @description Whether the blanket is clickable.
	     *
	     * @memberof Blanket
	     * @instance
	     * @emits Blanket#activate
	     * @type Boolean
	     * @default false
	     * @example @html <ak-blanket clickable></ak-blanket>
	     * @example @js component.clickable = true
	     */
                clickable: _skatejs.prop["boolean"]({
                    attribute: !0
                })
            }
        }), exports.events = events;
    }, /* 1 */
    , /* 2 */
    , /* 3 */
    /***/
    function(module, exports, __webpack_require__) {
        "use strict";
        function _interopRequireDefault(obj) {
            return obj && obj.__esModule ? obj : {
                "default": obj
            };
        }
        exports.__esModule = !0;
        var _defineProperty = __webpack_require__(4), _defineProperty2 = _interopRequireDefault(_defineProperty);
        exports["default"] = function(obj, key, value) {
            return key in obj ? (0, _defineProperty2["default"])(obj, key, {
                value: value,
                enumerable: !0,
                configurable: !0,
                writable: !0
            }) : obj[key] = value, obj;
        };
    }, /* 4 */
    /***/
    function(module, exports, __webpack_require__) {
        module.exports = {
            "default": __webpack_require__(5),
            __esModule: !0
        };
    }, /* 5 */
    /***/
    function(module, exports, __webpack_require__) {
        __webpack_require__(6);
        var $Object = __webpack_require__(9).Object;
        module.exports = function(it, key, desc) {
            return $Object.defineProperty(it, key, desc);
        };
    }, /* 6 */
    /***/
    function(module, exports, __webpack_require__) {
        var $export = __webpack_require__(7);
        // 19.1.2.4 / 15.2.3.6 Object.defineProperty(O, P, Attributes)
        $export($export.S + $export.F * !__webpack_require__(17), "Object", {
            defineProperty: __webpack_require__(13).f
        });
    }, /* 7 */
    /***/
    function(module, exports, __webpack_require__) {
        var global = __webpack_require__(8), core = __webpack_require__(9), ctx = __webpack_require__(10), hide = __webpack_require__(12), PROTOTYPE = "prototype", $export = function(type, name, source) {
            var key, own, out, IS_FORCED = type & $export.F, IS_GLOBAL = type & $export.G, IS_STATIC = type & $export.S, IS_PROTO = type & $export.P, IS_BIND = type & $export.B, IS_WRAP = type & $export.W, exports = IS_GLOBAL ? core : core[name] || (core[name] = {}), expProto = exports[PROTOTYPE], target = IS_GLOBAL ? global : IS_STATIC ? global[name] : (global[name] || {})[PROTOTYPE];
            IS_GLOBAL && (source = name);
            for (key in source) // contains in native
            own = !IS_FORCED && target && void 0 !== target[key], own && key in exports || (// export native or passed
            out = own ? target[key] : source[key], // prevent global pollution for namespaces
            exports[key] = IS_GLOBAL && "function" != typeof target[key] ? source[key] : IS_BIND && own ? ctx(out, global) : IS_WRAP && target[key] == out ? function(C) {
                var F = function(a, b, c) {
                    if (this instanceof C) {
                        switch (arguments.length) {
                          case 0:
                            return new C();

                          case 1:
                            return new C(a);

                          case 2:
                            return new C(a, b);
                        }
                        return new C(a, b, c);
                    }
                    return C.apply(this, arguments);
                };
                return F[PROTOTYPE] = C[PROTOTYPE], F;
            }(out) : IS_PROTO && "function" == typeof out ? ctx(Function.call, out) : out, // export proto methods to core.%CONSTRUCTOR%.methods.%NAME%
            IS_PROTO && ((exports.virtual || (exports.virtual = {}))[key] = out, // export proto methods to core.%CONSTRUCTOR%.prototype.%NAME%
            type & $export.R && expProto && !expProto[key] && hide(expProto, key, out)));
        };
        // type bitmap
        $export.F = 1, // forced
        $export.G = 2, // global
        $export.S = 4, // static
        $export.P = 8, // proto
        $export.B = 16, // bind
        $export.W = 32, // wrap
        $export.U = 64, // safe
        $export.R = 128, // real proto method for `library` 
        module.exports = $export;
    }, /* 8 */
    /***/
    function(module, exports) {
        // https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
        var global = module.exports = "undefined" != typeof window && window.Math == Math ? window : "undefined" != typeof self && self.Math == Math ? self : Function("return this")();
        "number" == typeof __g && (__g = global);
    }, /* 9 */
    /***/
    function(module, exports) {
        var core = module.exports = {
            version: "2.4.0"
        };
        "number" == typeof __e && (__e = core);
    }, /* 10 */
    /***/
    function(module, exports, __webpack_require__) {
        // optional / simple context binding
        var aFunction = __webpack_require__(11);
        module.exports = function(fn, that, length) {
            if (aFunction(fn), void 0 === that) return fn;
            switch (length) {
              case 1:
                return function(a) {
                    return fn.call(that, a);
                };

              case 2:
                return function(a, b) {
                    return fn.call(that, a, b);
                };

              case 3:
                return function(a, b, c) {
                    return fn.call(that, a, b, c);
                };
            }
            return function() {
                return fn.apply(that, arguments);
            };
        };
    }, /* 11 */
    /***/
    function(module, exports) {
        module.exports = function(it) {
            if ("function" != typeof it) throw TypeError(it + " is not a function!");
            return it;
        };
    }, /* 12 */
    /***/
    function(module, exports, __webpack_require__) {
        var dP = __webpack_require__(13), createDesc = __webpack_require__(21);
        module.exports = __webpack_require__(17) ? function(object, key, value) {
            return dP.f(object, key, createDesc(1, value));
        } : function(object, key, value) {
            return object[key] = value, object;
        };
    }, /* 13 */
    /***/
    function(module, exports, __webpack_require__) {
        var anObject = __webpack_require__(14), IE8_DOM_DEFINE = __webpack_require__(16), toPrimitive = __webpack_require__(20), dP = Object.defineProperty;
        exports.f = __webpack_require__(17) ? Object.defineProperty : function(O, P, Attributes) {
            if (anObject(O), P = toPrimitive(P, !0), anObject(Attributes), IE8_DOM_DEFINE) try {
                return dP(O, P, Attributes);
            } catch (e) {}
            if ("get" in Attributes || "set" in Attributes) throw TypeError("Accessors not supported!");
            return "value" in Attributes && (O[P] = Attributes.value), O;
        };
    }, /* 14 */
    /***/
    function(module, exports, __webpack_require__) {
        var isObject = __webpack_require__(15);
        module.exports = function(it) {
            if (!isObject(it)) throw TypeError(it + " is not an object!");
            return it;
        };
    }, /* 15 */
    /***/
    function(module, exports) {
        module.exports = function(it) {
            return "object" == typeof it ? null !== it : "function" == typeof it;
        };
    }, /* 16 */
    /***/
    function(module, exports, __webpack_require__) {
        module.exports = !__webpack_require__(17) && !__webpack_require__(18)(function() {
            return 7 != Object.defineProperty(__webpack_require__(19)("div"), "a", {
                get: function() {
                    return 7;
                }
            }).a;
        });
    }, /* 17 */
    /***/
    function(module, exports, __webpack_require__) {
        // Thank's IE8 for his funny defineProperty
        module.exports = !__webpack_require__(18)(function() {
            return 7 != Object.defineProperty({}, "a", {
                get: function() {
                    return 7;
                }
            }).a;
        });
    }, /* 18 */
    /***/
    function(module, exports) {
        module.exports = function(exec) {
            try {
                return !!exec();
            } catch (e) {
                return !0;
            }
        };
    }, /* 19 */
    /***/
    function(module, exports, __webpack_require__) {
        var isObject = __webpack_require__(15), document = __webpack_require__(8).document, is = isObject(document) && isObject(document.createElement);
        module.exports = function(it) {
            return is ? document.createElement(it) : {};
        };
    }, /* 20 */
    /***/
    function(module, exports, __webpack_require__) {
        // 7.1.1 ToPrimitive(input [, PreferredType])
        var isObject = __webpack_require__(15);
        // instead of the ES6 spec version, we didn't implement @@toPrimitive case
        // and the second argument - flag - preferred type is a string
        module.exports = function(it, S) {
            if (!isObject(it)) return it;
            var fn, val;
            if (S && "function" == typeof (fn = it.toString) && !isObject(val = fn.call(it))) return val;
            if ("function" == typeof (fn = it.valueOf) && !isObject(val = fn.call(it))) return val;
            if (!S && "function" == typeof (fn = it.toString) && !isObject(val = fn.call(it))) return val;
            throw TypeError("Can't convert object to primitive value");
        };
    }, /* 21 */
    /***/
    function(module, exports) {
        module.exports = function(bitmap, value) {
            return {
                enumerable: !(1 & bitmap),
                configurable: !(2 & bitmap),
                writable: !(4 & bitmap),
                value: value
            };
        };
    }, /* 22 */
    /***/
    function(module, exports, __webpack_require__) {
        !function(global, factory) {
            factory(exports, __webpack_require__(23));
        }(this, function(exports, incrementalDom) {
            function keys() {
                var obj = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {}, _ref = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {}, _ref$enumOnly = _ref.enumOnly, enumOnly = void 0 !== _ref$enumOnly && _ref$enumOnly, listOfKeys = Object[enumOnly ? "keys" : "getOwnPropertyNames"](obj);
                return "function" == typeof Object.getOwnPropertySymbols ? listOfKeys.concat(Object.getOwnPropertySymbols(obj)) : listOfKeys;
            }
            function create(def) {
                return function() {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
                    return args.unshift({}, def), assign.apply(void 0, args);
                };
            }
            function enter(object, props) {
                var saved = {};
                return Object.keys(props).forEach(function(key) {
                    saved[key] = object[key], object[key] = props[key];
                }), saved;
            }
            function exit(object, saved) {
                assign(object, saved);
            }
            // Adds or removes an event listener for an element.
            function applyEvent(elem, ename, newFunc) {
                var events = elem[$currentEventHandlers];
                events || (events = elem[$currentEventHandlers] = {});
                var oldFunc = events[ename];
                // Remove old listener so they don't double up.
                oldFunc && elem.removeEventListener(ename, oldFunc), // Bind new listener.
                newFunc && elem.addEventListener(ename, events[ename] = newFunc);
            }
            function resolveTagName(tname) {
                // If the tag name is a function, a Skate constructor or a standard function
                // is supported.
                //
                // - If a Skate constructor, the tag name is extracted from that.
                // - If a standard function, it is used as a helper.
                // If the tag name is a function, a Skate constructor or a standard function
                // is supported.
                //
                // - If a Skate constructor, the tag name is extracted from that.
                // - If a standard function, it is used as a helper.
                // Skate allows the consumer to use <slot /> and it will translate it to
                // <content /> if Shadow DOM V0 is preferred.
                return "function" == typeof tname ? tname[name$1] || tname : "slot" === tname && fallbackToV0 ? "content" : tname;
            }
            function elementOpenStart(tag) {
                var key = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : null, statics = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : null;
                overrideArgs = [ tag, key, statics ];
            }
            function elementOpenEnd() {
                var node = newElementOpen.apply(void 0, toConsumableArray(overrideArgs));
                // eslint-disable-line no-use-before-define
                return overrideArgs = null, node;
            }
            function wrapIdomFunc(func) {
                var tnameFuncHandler = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : noop;
                return function wrap() {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
                    if (args[0] = resolveTagName(args[0]), stackCurrentHelper = null, "function" == typeof args[0]) // If we've encountered a function, handle it according to the type of
                    // function that is being wrapped.
                    return stackCurrentHelper = args[0], tnameFuncHandler.apply(void 0, args);
                    if (stackChren.length) // We pass the wrap() function in here so that when it's called as
                    // children, it will queue up for the next stack, if there is one.
                    stackChren[stackChren.length - 1].push([ wrap, args ]); else {
                        if (func === elementOpen$1) {
                            if (skips) return ++skips;
                            var elem = func.apply(void 0, args);
                            return elem[$skip] && ++skips, elem;
                        }
                        if (func === incrementalDom.elementClose) {
                            // We only want to skip closing if it's not the last closing tag in the
                            // skipped tree because we keep the element that initiated the skpping.
                            if (1 === skips && incrementalDom.skip(), skips && --skips) return;
                            var _elem = func.apply(void 0, args), ref$$1 = _elem[ref$1];
                            // We delete so that it isn't called again for the same element. If the
                            // ref changes, or the element changes, this will be defined again.
                            // Execute the saved ref after esuring we've cleand up after it.
                            return delete _elem[ref$1], "function" == typeof ref$$1 && ref$$1(_elem), _elem;
                        }
                        // We must call elementOpenStart and elementOpenEnd even if we are
                        // skipping because they queue up attributes and then call elementClose.
                        if (!skips || func === elementOpenStart || func === elementOpenEnd) return func.apply(void 0, args);
                    }
                };
            }
            function newAttr() {
                for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) args[_key2] = arguments[_key2];
                stackCurrentHelper ? stackCurrentHelper[$stackCurrentHelperProps][args[0]] = args[1] : stackChren.length ? stackChren[stackChren.length - 1].push([ newAttr, args ]) : (overrideArgs.push(args[0]), 
                overrideArgs.push(args[1]));
            }
            function stackOpen(tname, key, statics) {
                for (var props$$1 = {
                    key: key,
                    statics: statics
                }, _len3 = arguments.length, attrs = Array(_len3 > 3 ? _len3 - 3 : 0), _key3 = 3; _key3 < _len3; _key3++) attrs[_key3 - 3] = arguments[_key3];
                for (var a = 0; a < attrs.length; a += 2) props$$1[attrs[a]] = attrs[a + 1];
                tname[$stackCurrentHelperProps] = props$$1, stackChren.push([]);
            }
            function stackClose(tname) {
                var chren = stackChren.pop(), props$$1 = tname[$stackCurrentHelperProps];
                delete tname[$stackCurrentHelperProps];
                var elemOrFn = tname(props$$1, function() {
                    return chren.forEach(function(args) {
                        return args[0].apply(args, toConsumableArray(args[1]));
                    });
                });
                return "function" == typeof elemOrFn ? elemOrFn() : elemOrFn;
            }
            // Ensure we call our overridden functions instead of the internal ones.
            function newElementVoid(tag) {
                for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) args[_key4 - 1] = arguments[_key4];
                return newElementOpen.apply(void 0, [ tag ].concat(args)), newElementClose(tag);
            }
            // Convenience function for declaring an Incremental DOM element using
            // hyperscript-style syntax.
            function element(tname, attrs) {
                // If attributes are a function, then they should be treated as children.
                for (var atype = "undefined" == typeof attrs ? "undefined" : _typeof(attrs), _len5 = arguments.length, chren = Array(_len5 > 2 ? _len5 - 2 : 0), _key5 = 2; _key5 < _len5; _key5++) chren[_key5 - 2] = arguments[_key5];
                // Ensure the attributes are an object. Null is considered an object so we
                // have to test for this explicitly.
                // We open the element so we can set attrs after.
                // Delete so special attrs don't actually get set.
                // Set attributes.
                // Close before we render the descendant tree.
                return "function" !== atype && "string" !== atype && "number" !== atype || chren.unshift(attrs), 
                null !== attrs && "object" === atype || (attrs = {}), newElementOpenStart(tname, attrs.key, attrs.statics), 
                delete attrs.key, delete attrs.statics, Object.keys(attrs).forEach(function(name$$1) {
                    return newAttr(name$$1, attrs[name$$1]);
                }), newElementOpenEnd(tname), chren.forEach(function(ch) {
                    var ctype = "undefined" == typeof ch ? "undefined" : _typeof(ch);
                    "function" === ctype ? ch() : "string" === ctype || "number" === ctype ? newText(ch) : Array.isArray(ch) && ch.forEach(function(sch) {
                        return sch();
                    });
                }), newElementClose(tname);
            }
            // Even further convenience for building a DSL out of JavaScript functions or hooking into standard
            // transpiles for JSX (React.createElement() / h).
            function builder() {
                for (var _len6 = arguments.length, tags = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) tags[_key6] = arguments[_key6];
                return 0 === tags.length ? function() {
                    for (var _len7 = arguments.length, args = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) args[_key7] = arguments[_key7];
                    return element.bind.apply(element, [ null ].concat(args));
                } : tags.map(function(tag) {
                    return function() {
                        for (var _len8 = arguments.length, args = Array(_len8), _key8 = 0; _key8 < _len8; _key8++) args[_key8] = arguments[_key8];
                        return element.bind.apply(element, [ null, tag ].concat(args));
                    };
                });
            }
            function microtaskDebounce(cbFunc) {
                var scheduled = !1, i = 0, cbArgs = [], elem = document.createElement("span"), observer = new MutationObserver(function() {
                    cbFunc.apply(void 0, toConsumableArray(cbArgs)), scheduled = !1, cbArgs = null;
                });
                return observer.observe(elem, {
                    childList: !0
                }), function() {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
                    cbArgs = args, scheduled || (scheduled = !0, elem.textContent = "" + i, i += 1);
                };
            }
            // We have to use setTimeout() for IE9 and 10 because the Mutation Observer
            // polyfill requires that the element be in the document to trigger Mutation
            // Events. Mutation Events are also synchronous and thus wouldn't debounce.
            //
            // The soonest we can set the timeout for in IE is 1 as they have issues when
            // setting to 0.
            function taskDebounce(cbFunc) {
                var scheduled = !1, cbArgs = [];
                return function() {
                    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) args[_key2] = arguments[_key2];
                    cbArgs = args, scheduled || (scheduled = !0, setTimeout(function() {
                        scheduled = !1, cbFunc.apply(void 0, toConsumableArray(cbArgs));
                    }, 1));
                };
            }
            function get$2(elem) {
                var props$$1 = {};
                return keys(elem.constructor.props).forEach(function(key) {
                    props$$1[key] = elem[key];
                }), props$$1;
            }
            function set$2(elem, newProps) {
                assign(elem, newProps), elem.constructor[renderer$1] && elem.constructor[renderer$1](elem);
            }
            function getDefaultValue(elem, name, opts) {
                return "function" == typeof opts["default"] ? opts["default"](elem, {
                    name: name
                }) : opts["default"];
            }
            function getInitialValue(elem, name, opts) {
                return "function" == typeof opts.initial ? opts.initial(elem, {
                    name: name
                }) : opts.initial;
            }
            function getPropData(elem, name) {
                var elemData = data(elem, "props");
                return elemData[name] || (elemData[name] = {});
            }
            function syncFirstTimeProp(elem, prop, propName, attributeName, propData) {
                var syncAttrValue = propData.lastAssignedValue;
                empty(syncAttrValue) && ("initial" in prop ? syncAttrValue = getInitialValue(elem, propName, prop) : "default" in prop && (syncAttrValue = getDefaultValue(elem, propName, prop))), 
                !empty(syncAttrValue) && prop.serialize && (syncAttrValue = prop.serialize(syncAttrValue)), 
                empty(syncAttrValue) || (propData.syncingAttribute = !0, elem.setAttribute(attributeName, syncAttrValue));
            }
            function syncExistingProp(elem, prop, propName, attributeName, propData) {
                if (attributeName && !propData.settingAttribute) {
                    var internalValue = propData.internalValue, serializedValue = prop.serialize(internalValue), currentAttrValue = elem.getAttribute(attributeName), serializedIsEmpty = empty(serializedValue), attributeChanged = !(serializedIsEmpty && empty(currentAttrValue) || serializedValue === currentAttrValue);
                    propData.syncingAttribute = !0;
                    var shouldRemoveAttribute = empty(propData.lastAssignedValue);
                    shouldRemoveAttribute || serializedIsEmpty ? elem.removeAttribute(attributeName) : elem.setAttribute(attributeName, serializedValue), 
                    !attributeChanged && propData.syncingAttribute && (propData.syncingAttribute = !1);
                }
                // Allow the attribute to be linked again.
                propData.settingAttribute = !1;
            }
            function syncPropToAttr(elem, prop, propName, isFirstSync) {
                var attributeName = data(elem, "propertyLinks")[propName], propData = getPropData(elem, propName);
                attributeName && (isFirstSync ? syncFirstTimeProp(elem, prop, propName, attributeName, propData) : syncExistingProp(elem, prop, propName, attributeName, propData));
            }
            // Abstracts shadow root across v1, v0 and no support.
            // Once v1 is supported everywhere, we can call elem.attachShadow() directly
            // and remove this function.
            function attachShadow(elem) {
                return shadowDomV1 ? elem.attachShadow({
                    mode: "open"
                }) : shadowDomV0 ? elem.createShadowRoot() : elem;
            }
            function getOrAttachShadow(elem) {
                return elem[shadowRoot] || (elem[shadowRoot] = attachShadow(elem));
            }
            function callConstructor(elem) {
                var elemData = data(elem), readyCallbacks = elemData.readyCallbacks, constructor = elem.constructor;
                // Ensures that this can never be called twice.
                elem[created$1] || (elem[created$1] = !0, // Set up a renderer that is debounced for property sets to call directly.
                elem[rendererDebounced] = debounce(constructor[renderer$1].bind(constructor)), // Set up property lifecycle.
                constructor.props && constructor[props] && constructor[props](elem), // Props should be set up before calling this.
                "function" == typeof constructor.created && constructor.created(elem), // Created should be set before invoking the ready listeners.
                readyCallbacks && (readyCallbacks.forEach(function(cb) {
                    return cb(elem);
                }), delete elemData.readyCallbacks), // In v0 we must ensure the attributeChangedCallback is called for attrs
                // that aren't linked to props so that the callback behaves the same no
                // matter if v0 or v1 is being used.
                customElementsV0 && constructor.observedAttributes.forEach(function(name$$1) {
                    var propertyName = data(elem, "attributeLinks")[name$$1];
                    propertyName || elem.attributeChangedCallback(name$$1, null, elem.getAttribute(name$$1));
                }));
            }
            function syncPropsToAttrs(elem) {
                var props$$1 = elem.constructor.props;
                Object.keys(props$$1).forEach(function(propName) {
                    var prop = props$$1[propName];
                    syncPropToAttr(elem, prop, propName, !0);
                });
            }
            function callConnected(elem) {
                var constructor = elem.constructor;
                syncPropsToAttrs(elem), elem[connected] = !0, elem[rendererDebounced](elem), "function" == typeof constructor.attached && constructor.attached(elem), 
                elem.setAttribute("defined", "");
            }
            function callDisconnected(elem) {
                var constructor = elem.constructor;
                elem[connected] = !1, "function" == typeof constructor.detached && constructor.detached(elem);
            }
            // v1
            function Component() {
                for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) args[_key] = arguments[_key];
                var elem = reflect ? Reflect.construct(HTMLElement, args, this.constructor) : HTMLElement.call(this, args[0]);
                return callConstructor(elem), elem;
            }
            function createNativePropertyDefinition(name$$1, opts) {
                var prop = {
                    configurable: !0,
                    enumerable: !0
                };
                return prop.created = function(elem) {
                    var propData = getPropData(elem, name$$1), attributeName = opts.attribute === !0 ? dashCase(name$$1) : opts.attribute, initialValue = elem[name$$1];
                    // Store property to attribute link information.
                    data(elem, "attributeLinks")[attributeName] = name$$1, data(elem, "propertyLinks")[name$$1] = attributeName, 
                    // Set up initial value if it wasn't specified.
                    empty(initialValue) && (attributeName && elem.hasAttribute(attributeName) ? initialValue = opts.deserialize(elem.getAttribute(attributeName)) : "initial" in opts ? initialValue = getInitialValue(elem, name$$1, opts) : "default" in opts && (initialValue = getDefaultValue(elem, name$$1, opts))), 
                    propData.internalValue = opts.coerce ? opts.coerce(initialValue) : initialValue;
                }, prop.get = function() {
                    var propData = getPropData(this, name$$1), internalValue = propData.internalValue;
                    return "function" == typeof opts.get ? opts.get(this, {
                        name: name$$1,
                        internalValue: internalValue
                    }) : internalValue;
                }, prop.set = function(newValue) {
                    var propData = getPropData(this, name$$1);
                    propData.lastAssignedValue = newValue;
                    var oldValue = propData.oldValue;
                    empty(oldValue) && (oldValue = null), empty(newValue) && (newValue = getDefaultValue(this, name$$1, opts)), 
                    "function" == typeof opts.coerce && (newValue = opts.coerce(newValue));
                    var changeData = {
                        name: name$$1,
                        newValue: newValue,
                        oldValue: oldValue
                    };
                    "function" == typeof opts.set && opts.set(this, changeData), // Queue a re-render.
                    this[rendererDebounced](this), // Update prop data so we can use it next time.
                    propData.internalValue = propData.oldValue = newValue, // Link up the attribute.
                    this[connected] && syncPropToAttr(this, opts, name$$1, !1);
                }, prop;
            }
            /* eslint no-bitwise: 0 */
            // Ensures that definitions passed as part of the constructor are functions
            // that return property definitions used on the element.
            function ensurePropertyFunctions(Ctor) {
                var props$$1 = Ctor.props;
                return keys(props$$1).reduce(function(descriptors, descriptorName) {
                    return descriptors[descriptorName] = props$$1[descriptorName], "function" != typeof descriptors[descriptorName] && (descriptors[descriptorName] = initProps(descriptors[descriptorName])), 
                    descriptors;
                }, {});
            }
            // Ensures the property definitions are transformed to objects that can be used
            // to create properties on the element.
            function ensurePropertyDefinitions(Ctor) {
                var props$$1 = ensurePropertyFunctions(Ctor);
                return keys(props$$1).reduce(function(descriptors, descriptorName) {
                    return descriptors[descriptorName] = props$$1[descriptorName](descriptorName), descriptors;
                }, {});
            }
            // Ensures linked properties that have linked attributes are pre-formatted to
            // the attribute name in which they are linked.
            function formatLinkedAttributes(Ctor) {
                var observedAttributes = Ctor.observedAttributes, props$$1 = Ctor.props;
                props$$1 && (keys(props$$1).forEach(function(name$$1) {
                    var prop = props$$1[name$$1], attr = prop.attribute;
                    if (attr) {
                        // Ensure the property is updated.
                        var linkedAttr = prop.attribute = attr === !0 ? dashCase(name$$1) : attr;
                        // Automatically observe the attribute since they're linked from the
                        // attributeChangedCallback.
                        observedAttributes.indexOf(linkedAttr) === -1 && observedAttributes.push(linkedAttr);
                    }
                }), // Merge observed attributes.
                Object.defineProperty(Ctor, "observedAttributes", {
                    configurable: !0,
                    enumerable: !0,
                    get: function() {
                        return observedAttributes;
                    }
                }));
            }
            function createInitProps(Ctor) {
                var props$$1 = ensurePropertyDefinitions(Ctor);
                return function(elem) {
                    props$$1 && keys(props$$1).forEach(function(name$$1) {
                        var prop = props$$1[name$$1];
                        prop.created(elem), // https://bugs.webkit.org/show_bug.cgi?id=49739
                        //
                        // When Webkit fixes that bug so that native property accessors can be
                        // retrieved, we can move defining the property to the prototype and away
                        // from having to do if for every instance as all other browsers support
                        // this.
                        Object.defineProperty(elem, name$$1, prop);
                    });
                };
            }
            function generateUniqueName(name$$1) {
                // http://stackoverflow.com/questions/105034/create-guid-uuid-in-javascript/2117523#2117523
                var rand = "xxxxxxxx".replace(/[xy]/g, function(c) {
                    var r = 16 * Math.random() | 0, v = "x" === c ? r : 3 & r | 8;
                    // eslint-disable-line no-mixed-operators
                    return v.toString(16);
                });
                return name$$1 + "-" + rand;
            }
            function prepareForRegistration(name$$1, Ctor) {
                Ctor[name$1] = name$$1, Ctor[props] = createInitProps(Ctor);
            }
            function registerV0Element(name$$1, Ctor) {
                var res = void 0, uniqueName = void 0;
                try {
                    prepareForRegistration(name$$1, Ctor), res = document.registerElement(name$$1, Ctor);
                } catch (e) {
                    uniqueName = generateUniqueName(name$$1), prepareForRegistration(uniqueName, Ctor), 
                    res = document.registerElement(uniqueName, Ctor);
                }
                return res;
            }
            function registerV1Element(name$$1, Ctor) {
                var uniqueName = name$$1;
                return window.customElements.get(name$$1) && (uniqueName = generateUniqueName(name$$1)), 
                prepareForRegistration(uniqueName, Ctor), window.customElements.define(uniqueName, Ctor, Ctor["extends"] ? {
                    "extends": Ctor["extends"]
                } : null), Ctor;
            }
            function createCustomEvent(name) {
                var opts = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : {}, detail = opts.detail;
                delete opts.detail;
                var e = void 0;
                return Event ? (e = new Event(name, opts), "undefined" != typeof detail && Object.defineProperty(e, "detail", {
                    value: detail
                })) : (e = document.createEvent("CustomEvent"), e.initCustomEvent(name, opts.bubbles, opts.cancelable, detail)), 
                e;
            }
            function getValue(elem) {
                var type = elem.type;
                return "checkbox" === type || "radio" === type ? !!elem.checked && (elem.value || !0) : elem.value;
            }
            // We are not using Object.assign if it is defined since it will cause problems when Symbol is polyfilled.
            // Apparently Object.assign (or any polyfill for this method) does not copy non-native Symbols.
            var assign = function(obj) {
                for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) args[_key - 1] = arguments[_key];
                // eslint-disable-line no-return-assign
                return args.forEach(function(arg) {
                    return keys(arg).forEach(function(name) {
                        return obj[name] = arg[name];
                    });
                }), obj;
            }, empty = function(val) {
                return "undefined" == typeof val || null === val;
            }, alwaysUndefinedIfNotANumberOrNumber = function(val) {
                return isNaN(val) ? void 0 : Number(val);
            }, alwaysUndefinedIfEmptyOrString = function(val) {
                return empty(val) ? void 0 : String(val);
            }, array = create({
                coerce: function(val) {
                    return Array.isArray(val) ? val : [ val ];
                },
                "default": function() {
                    return [];
                },
                deserialize: JSON.parse,
                serialize: JSON.stringify
            }), boolean = create({
                coerce: function(value) {
                    return !!value;
                },
                "default": !1,
                deserialize: function(value) {
                    return !(null === value);
                },
                serialize: function(value) {
                    return value ? "" : void 0;
                }
            }), number = create({
                "default": 0,
                coerce: alwaysUndefinedIfNotANumberOrNumber,
                deserialize: alwaysUndefinedIfNotANumberOrNumber,
                serialize: alwaysUndefinedIfNotANumberOrNumber
            }), string = create({
                "default": "",
                coerce: alwaysUndefinedIfEmptyOrString,
                deserialize: alwaysUndefinedIfEmptyOrString,
                serialize: alwaysUndefinedIfEmptyOrString
            }), prop = Object.freeze({
                create: create,
                array: array,
                "boolean": boolean,
                number: number,
                string: string
            }), connected = "____skate_connected", created$1 = "____skate_created", name$1 = "____skate_name", props = "____skate_props", ref$1 = "____skate_ref", renderer$1 = "____skate_renderer", rendering = "____skate_rendering", rendererDebounced = "____skate_rendererDebounced", shadowRoot = "____skate_shadowRoot", updated$1 = "____skate_updated", symbols$1 = Object.freeze({
                name: name$1,
                shadowRoot: shadowRoot
            }), doc = document, win = window, div = doc.createElement("div"), customElementsV0 = !!doc.registerElement, customElementsV1 = !!win.customElements, shadowDomV0 = !!div.createShadowRoot, shadowDomV1 = !!div.attachShadow, reflect = "Reflect" in window, propContext = function(object, props) {
                return function(func) {
                    return function() {
                        var saved = enter(object, props), result = func.apply(void 0, arguments);
                        return exit(object, saved), result;
                    };
                };
            }, _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj) {
                return typeof obj;
            } : function(obj) {
                return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
            }, classCallCheck = (function() {
                function AwaitValue(value) {
                    this.value = value;
                }
                function AsyncGenerator(gen) {
                    function send(key, arg) {
                        return new Promise(function(resolve, reject) {
                            var request = {
                                key: key,
                                arg: arg,
                                resolve: resolve,
                                reject: reject,
                                next: null
                            };
                            back ? back = back.next = request : (front = back = request, resume(key, arg));
                        });
                    }
                    function resume(key, arg) {
                        try {
                            var result = gen[key](arg), value = result.value;
                            value instanceof AwaitValue ? Promise.resolve(value.value).then(function(arg) {
                                resume("next", arg);
                            }, function(arg) {
                                resume("throw", arg);
                            }) : settle(result.done ? "return" : "normal", result.value);
                        } catch (err) {
                            settle("throw", err);
                        }
                    }
                    function settle(type, value) {
                        switch (type) {
                          case "return":
                            front.resolve({
                                value: value,
                                done: !0
                            });
                            break;

                          case "throw":
                            front.reject(value);
                            break;

                          default:
                            front.resolve({
                                value: value,
                                done: !1
                            });
                        }
                        front = front.next, front ? resume(front.key, front.arg) : back = null;
                    }
                    var front, back;
                    this._invoke = send, "function" != typeof gen["return"] && (this["return"] = void 0);
                }
                return "function" == typeof Symbol && Symbol.asyncIterator && (AsyncGenerator.prototype[Symbol.asyncIterator] = function() {
                    return this;
                }), AsyncGenerator.prototype.next = function(arg) {
                    return this._invoke("next", arg);
                }, AsyncGenerator.prototype["throw"] = function(arg) {
                    return this._invoke("throw", arg);
                }, AsyncGenerator.prototype["return"] = function(arg) {
                    return this._invoke("return", arg);
                }, {
                    wrap: function(fn) {
                        return function() {
                            return new AsyncGenerator(fn.apply(this, arguments));
                        };
                    },
                    await: function(value) {
                        return new AwaitValue(value);
                    }
                };
            }(), function(instance, Constructor) {
                if (!(instance instanceof Constructor)) throw new TypeError("Cannot call a class as a function");
            }), defineProperty = function(obj, key, value) {
                return key in obj ? Object.defineProperty(obj, key, {
                    value: value,
                    enumerable: !0,
                    configurable: !0,
                    writable: !0
                }) : obj[key] = value, obj;
            }, inherits = function(subClass, superClass) {
                if ("function" != typeof superClass && null !== superClass) throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
                subClass.prototype = Object.create(superClass && superClass.prototype, {
                    constructor: {
                        value: subClass,
                        enumerable: !1,
                        writable: !0,
                        configurable: !0
                    }
                }), superClass && (Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass);
            }, possibleConstructorReturn = function(self, call) {
                if (!self) throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return !call || "object" != typeof call && "function" != typeof call ? self : call;
            }, toConsumableArray = function(arr) {
                if (Array.isArray(arr)) {
                    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];
                    return arr2;
                }
                return Array.from(arr);
            }, applyDefault = incrementalDom.attributes[incrementalDom.symbols["default"]], fallbackToV0 = !shadowDomV1 && shadowDomV0, stackChren = [], $skip = "__skip", $currentEventHandlers = "__events", $stackCurrentHelperProps = "__props", stackCurrentHelper = void 0, overrideArgs = void 0, skips = 0, noop = function() {}, attributesContext = propContext(incrementalDom.attributes, defineProperty({
                // Attributes that shouldn't be applied to the DOM.
                key: noop,
                statics: noop,
                // Attributes that *must* be set via a property on all elements.
                checked: incrementalDom.applyProp,
                className: incrementalDom.applyProp,
                disabled: incrementalDom.applyProp,
                value: incrementalDom.applyProp,
                // V0 Shadow DOM to V1 normalisation.
                name: function(elem, _name, value) {
                    "CONTENT" === elem.tagName && (_name = "select", value = '[slot="' + value + '"]'), 
                    applyDefault(elem, _name, value);
                },
                // Ref handler.
                ref: function(elem, name$$1, value) {
                    elem[ref$1] = value;
                },
                // Skip handler.
                skip: function(elem, name$$1, value) {
                    value ? elem[$skip] = !0 : delete elem[$skip];
                }
            }, incrementalDom.symbols["default"], function(elem, name$$1, value) {
                // Custom element properties should be set as properties.
                var props$$1 = elem.constructor.props;
                if (props$$1 && name$$1 in props$$1) return incrementalDom.applyProp(elem, name$$1, value);
                // Boolean false values should not set attributes at all.
                if (value === !1) return applyDefault(elem, name$$1);
                // Handle built-in and custom events.
                if (0 === name$$1.indexOf("on")) {
                    var firstChar = name$$1[2], eventName = void 0;
                    if ("-" === firstChar ? eventName = name$$1.substring(3) : firstChar === firstChar.toUpperCase() && (eventName = firstChar.toLowerCase() + name$$1.substring(3)), 
                    eventName) return void applyEvent(elem, eventName, value);
                }
                // Set defined props on the element directly. This ensures properties like
                // "value" on <input> elements get set correctly. Setting those as attributes
                // doesn't always work and setting props is faster than attributes.
                //
                // However, certain props on SVG elements are readonly and error when you try
                // to set them.
                // Set defined props on the element directly. This ensures properties like
                // "value" on <input> elements get set correctly. Setting those as attributes
                // doesn't always work and setting props is faster than attributes.
                //
                // However, certain props on SVG elements are readonly and error when you try
                // to set them.
                // Fallback to default IncrementalDOM behaviour.
                return name$$1 in elem && !("ownerSVGElement" in elem) ? void incrementalDom.applyProp(elem, name$$1, value) : void applyDefault(elem, name$$1, value);
            })), elementOpen$1 = attributesContext(incrementalDom.elementOpen), newElementOpenStart = wrapIdomFunc(elementOpenStart, stackOpen), newElementOpenEnd = wrapIdomFunc(elementOpenEnd), newElementOpen = wrapIdomFunc(elementOpen$1, stackOpen), newElementClose = wrapIdomFunc(incrementalDom.elementClose, stackClose), newText = wrapIdomFunc(incrementalDom.text), vdom = Object.freeze({
                element: element,
                builder: builder,
                attr: newAttr,
                elementClose: newElementClose,
                elementOpen: newElementOpen,
                elementOpenEnd: newElementOpenEnd,
                elementOpenStart: newElementOpenStart,
                elementVoid: newElementVoid,
                text: newText
            }), data = function(element) {
                var namespace = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : "", data = element.__SKATE_DATA || (element.__SKATE_DATA = {});
                return namespace && (data[namespace] || (data[namespace] = {})) || data;
            }, nativeHints = [ "native code", "[object MutationObserverConstructor]" ], native = function(fn) {
                return nativeHints.map(function(hint) {
                    return (fn || "").toString().indexOf([ hint ]) > -1;
                }).reduce(function(a, b) {
                    return a || b;
                });
            }, _window$2 = window, MutationObserver = _window$2.MutationObserver, debounce = native(MutationObserver) ? microtaskDebounce : taskDebounce, getOwnPropertyDescriptors = function() {
                var obj = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {};
                return keys(obj).reduce(function(prev, curr) {
                    return prev[curr] = Object.getOwnPropertyDescriptor(obj, curr), prev;
                }, {});
            }, props$1 = function(elem, newProps) {
                return "undefined" == typeof newProps ? get$2(elem) : set$2(elem, newProps);
            }, _window$1 = window, HTMLElement = _window$1.HTMLElement;
            // v1
            Component.observedAttributes = [], // Skate
            Component.props = {}, // Skate
            Component.extend = function() {
                var definition = arguments.length > 0 && void 0 !== arguments[0] ? arguments[0] : {}, Base = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : this, Ctor = function(_Base) {
                    function Ctor() {
                        return classCallCheck(this, Ctor), possibleConstructorReturn(this, (Ctor.__proto__ || Object.getPrototypeOf(Ctor)).apply(this, arguments));
                    }
                    return inherits(Ctor, _Base), Ctor;
                }(Base);
                // Pass on statics from the Base if not supported (IE 9 and 10).
                if (!Ctor.observedAttributes) {
                    var staticOpts = getOwnPropertyDescriptors(Base);
                    delete staticOpts.length, delete staticOpts.prototype, Object.defineProperties(Ctor, staticOpts);
                }
                // For inheriting from the object literal.
                var opts = getOwnPropertyDescriptors(definition), prot = getOwnPropertyDescriptors(definition.prototype);
                // Prototype is non configurable (but is writable).
                // Pass on static and instance members from the definition.
                return delete opts.prototype, Object.defineProperties(Ctor, opts), Object.defineProperties(Ctor.prototype, prot), 
                Ctor;
            }, // Skate
            //
            // Incremental DOM renderer.
            Component.renderer = function(_ref) {
                var elem = _ref.elem, render = _ref.render, shadowRoot$$1 = _ref.shadowRoot;
                incrementalDom.patchInner(shadowRoot$$1, function() {
                    var possibleFn = render(elem);
                    "function" == typeof possibleFn ? possibleFn() : Array.isArray(possibleFn) && possibleFn.forEach(function(fn) {
                        "function" == typeof fn && fn();
                    });
                });
            }, // Skate
            //
            // This is a default implementation that does strict equality copmarison on
            // previous props and next props. It synchronously renders on the first prop
            // that is different and returns immediately.
            Component.updated = function(elem, prev) {
                if (!prev) return !0;
                for (var allKeys = keys(prev), i = 0; i < allKeys.length; i += 1) if (prev[allKeys[i]] !== elem[allKeys[i]]) return !0;
                return !1;
            }, // Skate
            //
            // Calls the user-defined updated() lifecycle callback.
            Component[updated$1] = function(elem) {
                if ("function" == typeof this.updated) {
                    var prev = elem[props];
                    return elem[props] = props$1(elem), this.updated(elem, prev);
                }
                return !0;
            }, // Skate
            //
            // Goes through the user-defined render lifecycle.
            Component[renderer$1] = function(elem) {
                if (!elem[rendering] && elem[connected]) {
                    // Flag as rendering. This prevents anything from trying to render - or
                    // queueing a render - while there is a pending render.
                    elem[rendering] = !0;
                    var shouldRender = this[updated$1](elem);
                    // Even though this would ideally be checked in the updated() callback,
                    // it may not be, so we ensure that there is a point in proceeding.
                    if (!this.render || !this.renderer) return void (elem[rendering] = !1);
                    shouldRender && (this.renderer({
                        elem: elem,
                        render: this.render,
                        shadowRoot: getOrAttachShadow(elem)
                    }), "function" == typeof this.rendered && this.rendered(elem)), elem[rendering] = !1;
                }
            }, Component.prototype = Object.create(HTMLElement.prototype, {
                // v1
                connectedCallback: {
                    configurable: !0,
                    value: function() {
                        callConnected(this);
                    }
                },
                // v1
                disconnectedCallback: {
                    configurable: !0,
                    value: function() {
                        callDisconnected(this);
                    }
                },
                // v0 and v1
                attributeChangedCallback: {
                    configurable: !0,
                    value: function(name$$1, oldValue, newValue) {
                        var _constructor = this.constructor, attributeChanged = _constructor.attributeChanged, observedAttributes = _constructor.observedAttributes, propertyName = data(this, "attributeLinks")[name$$1];
                        // In V0 we have to ensure the attribute is being observed.
                        if (!customElementsV0 || observedAttributes.indexOf(name$$1) !== -1) {
                            if (propertyName) {
                                var propData = data(this, "props")[propertyName];
                                // This ensures a property set doesn't cause the attribute changed
                                // handler to run again once we set this flag. This only ever has a
                                // chance to run when you set an attribute, it then sets a property and
                                // then that causes the attribute to be set again.
                                if (propData.syncingAttribute) propData.syncingAttribute = !1; else {
                                    // Sync up the property.
                                    var propOpts = this.constructor.props[propertyName];
                                    propData.settingAttribute = !0;
                                    var newPropVal = null !== newValue && propOpts.deserialize ? propOpts.deserialize(newValue) : newValue;
                                    this[propertyName] = newPropVal;
                                }
                            }
                            attributeChanged && attributeChanged(this, {
                                name: name$$1,
                                newValue: newValue,
                                oldValue: oldValue
                            });
                        }
                    }
                },
                // v0
                createdCallback: {
                    configurable: !0,
                    value: function() {
                        callConstructor(this);
                    }
                },
                // v0
                attachedCallback: {
                    configurable: !0,
                    value: function() {
                        callConnected(this);
                    }
                },
                // v0
                detachedCallback: {
                    configurable: !0,
                    value: function() {
                        callDisconnected(this);
                    }
                }
            });
            var dashCase = function(str) {
                return str.split(/([A-Z])/).reduce(function(one, two, idx) {
                    var dash = one && idx % 2 !== 0 ? "-" : "";
                    return "" + one + dash + two.toLowerCase();
                });
            }, initProps = function(opts) {
                return opts = opts || {}, "function" == typeof opts && (opts = {
                    coerce: opts
                }), function(name$$1) {
                    return createNativePropertyDefinition(name$$1, assign({
                        "default": null,
                        deserialize: function(value) {
                            return value;
                        },
                        serialize: function(value) {
                            return value;
                        }
                    }, opts));
                };
            }, define = function(name$$1, opts) {
                if (void 0 === opts) throw new Error("You have to define options to register a component " + name$$1);
                var Ctor = "object" === ("undefined" == typeof opts ? "undefined" : _typeof(opts)) ? Component.extend(opts) : opts;
                if (formatLinkedAttributes(Ctor), customElementsV1) return registerV1Element(name$$1, Ctor);
                if (customElementsV0) return registerV0Element(name$$1, Ctor);
                throw new Error("Skate requires native custom element support or a polyfill.");
            }, Event = function(TheEvent) {
                if (TheEvent) try {
                    new TheEvent("emit-init");
                } catch (e) {
                    return;
                }
                return TheEvent;
            }(window.Event), emit = function(elem, name) {
                var opts = arguments.length > 2 && void 0 !== arguments[2] ? arguments[2] : {};
                return void 0 === opts.bubbles && (opts.bubbles = !0), void 0 === opts.cancelable && (opts.cancelable = !0), 
                void 0 === opts.composed && (opts.composed = !0), elem.dispatchEvent(createCustomEvent(name, opts));
            }, link = function(elem, target) {
                return function(e) {
                    var value = getValue(e.target), localTarget = target || e.target.name || "value";
                    if (localTarget.indexOf(".") > -1) {
                        var parts = localTarget.split("."), firstPart = parts[0], propName = parts.pop(), obj = parts.reduce(function(prev, curr) {
                            return prev && prev[curr];
                        }, elem);
                        obj[propName || e.target.name] = value, props$1(elem, defineProperty({}, firstPart, elem[firstPart]));
                    } else props$1(elem, defineProperty({}, localTarget, value));
                };
            }, ready = function(elem, done) {
                var info = data(elem);
                elem[created$1] ? done(elem) : info.readyCallbacks ? info.readyCallbacks.push(done) : info.readyCallbacks = [ done ];
            }, h = builder();
            exports.Component = Component, exports.define = define, exports.emit = emit, exports.h = h, 
            exports.link = link, exports.prop = prop, exports.props = props$1, exports.ready = ready, 
            exports.symbols = symbols$1, exports.vdom = vdom, Object.defineProperty(exports, "__esModule", {
                value: !0
            });
        });
    }, /* 23 */
    /***/
    function(module, exports, __webpack_require__) {
        /**
	 * @license
	 * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
	 *
	 * Licensed under the Apache License, Version 2.0 (the "License");
	 * you may not use this file except in compliance with the License.
	 * You may obtain a copy of the License at
	 *
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 * Unless required by applicable law or agreed to in writing, software
	 * distributed under the License is distributed on an "AS-IS" BASIS,
	 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	 * See the License for the specific language governing permissions and
	 * limitations under the License.
	 */
        "use strict";
        /**
	 * Keeps track of information needed to perform diffs for a given DOM node.
	 * @param {!string} nodeName
	 * @param {?string=} key
	 * @constructor
	 */
        function NodeData(nodeName, key) {
            /**
	   * The attributes and their values.
	   * @const {!Object<string, *>}
	   */
            this.attrs = createMap(), /**
	   * An array of attribute name/value pairs, used for quickly diffing the
	   * incomming attributes to see if the DOM node's attributes need to be
	   * updated.
	   * @const {Array<*>}
	   */
            this.attrsArr = [], /**
	   * The incoming attributes for this Node, before they are updated.
	   * @const {!Object<string, *>}
	   */
            this.newAttrs = createMap(), /**
	   * The key used to identify this node, used to preserve DOM nodes when they
	   * move within their parent.
	   * @const
	   */
            this.key = key, /**
	   * Keeps track of children within this node by their key.
	   * {?Object<string, !Element>}
	   */
            this.keyMap = null, /**
	   * Whether or not the keyMap is currently valid.
	   * {boolean}
	   */
            this.keyMapValid = !0, /**
	   * The node name for this node.
	   * @const {string}
	   */
            this.nodeName = nodeName, /**
	   * @type {?string}
	   */
            this.text = null;
        }
        /**
	 * Keeps track of the state of a patch.
	 * @constructor
	 */
        function Context() {
            /**
	   * @type {(Array<!Node>|undefined)}
	   */
            this.created = notifications.nodesCreated && [], /**
	   * @type {(Array<!Node>|undefined)}
	   */
            this.deleted = notifications.nodesDeleted && [];
        }
        /**
	 * Copyright 2015 The Incremental DOM Authors. All Rights Reserved.
	 *
	 * Licensed under the Apache License, Version 2.0 (the "License");
	 * you may not use this file except in compliance with the License.
	 * You may obtain a copy of the License at
	 *
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 * Unless required by applicable law or agreed to in writing, software
	 * distributed under the License is distributed on an "AS-IS" BASIS,
	 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	 * See the License for the specific language governing permissions and
	 * limitations under the License.
	 */
        /**
	 * A cached reference to the hasOwnProperty function.
	 */
        var hasOwnProperty = Object.prototype.hasOwnProperty, create = Object.create, has = function(map, property) {
            return hasOwnProperty.call(map, property);
        }, createMap = function() {
            return create(null);
        }, initData = function(node, nodeName, key) {
            var data = new NodeData(nodeName, key);
            return node.__incrementalDOMData = data, data;
        }, getData = function(node) {
            var data = node.__incrementalDOMData;
            if (!data) {
                var nodeName = node.nodeName.toLowerCase(), key = null;
                node instanceof Element && (key = node.getAttribute("key")), data = initData(node, nodeName, key);
            }
            return data;
        }, symbols = {
            "default": "__default",
            placeholder: "__placeholder"
        }, getNamespace = function(name) {
            return 0 === name.lastIndexOf("xml:", 0) ? "http://www.w3.org/XML/1998/namespace" : 0 === name.lastIndexOf("xlink:", 0) ? "http://www.w3.org/1999/xlink" : void 0;
        }, applyAttr = function(el, name, value) {
            if (null == value) el.removeAttribute(name); else {
                var attrNS = getNamespace(name);
                attrNS ? el.setAttributeNS(attrNS, name, value) : el.setAttribute(name, value);
            }
        }, applyProp = function(el, name, value) {
            el[name] = value;
        }, applyStyle = function(el, name, style) {
            if ("string" == typeof style) el.style.cssText = style; else {
                el.style.cssText = "";
                var elStyle = el.style, obj = /** @type {!Object<string,string>} */ style;
                for (var prop in obj) has(obj, prop) && (elStyle[prop] = obj[prop]);
            }
        }, applyAttributeTyped = function(el, name, value) {
            var type = typeof value;
            "object" === type || "function" === type ? applyProp(el, name, value) : applyAttr(el, name, /** @type {?(boolean|number|string)} */ value);
        }, updateAttribute = function(el, name, value) {
            var data = getData(el), attrs = data.attrs;
            if (attrs[name] !== value) {
                var mutator = attributes[name] || attributes[symbols["default"]];
                mutator(el, name, value), attrs[name] = value;
            }
        }, attributes = createMap();
        // Special generic mutator that's called for any attribute that does not
        // have a specific mutator.
        attributes[symbols["default"]] = applyAttributeTyped, attributes[symbols.placeholder] = function() {}, 
        attributes.style = applyStyle;
        /**
	 * Gets the namespace to create an element (of a given tag) in.
	 * @param {string} tag The tag to get the namespace for.
	 * @param {?Node} parent
	 * @return {?string} The namespace to create the tag in.
	 */
        var getNamespaceForTag = function(tag, parent) {
            return "svg" === tag ? "http://www.w3.org/2000/svg" : "foreignObject" === getData(parent).nodeName ? null : parent.namespaceURI;
        }, createElement = function(doc, parent, tag, key, statics) {
            var namespace = getNamespaceForTag(tag, parent), el = void 0;
            if (el = namespace ? doc.createElementNS(namespace, tag) : doc.createElement(tag), 
            initData(el, tag, key), statics) for (var i = 0; i < statics.length; i += 2) updateAttribute(el, /** @type {!string}*/ statics[i], statics[i + 1]);
            return el;
        }, createText = function(doc) {
            var node = doc.createTextNode("");
            return initData(node, "#text", null), node;
        }, createKeyMap = function(el) {
            for (var map = createMap(), child = el.firstElementChild; child; ) {
                var key = getData(child).key;
                key && (map[key] = child), child = child.nextElementSibling;
            }
            return map;
        }, getKeyMap = function(el) {
            var data = getData(el);
            return data.keyMap || (data.keyMap = createKeyMap(el)), data.keyMap;
        }, getChild = function(parent, key) {
            return key ? getKeyMap(parent)[key] : null;
        }, registerChild = function(parent, key, child) {
            getKeyMap(parent)[key] = child;
        }, notifications = {
            /**
	   * Called after patch has compleated with any Nodes that have been created
	   * and added to the DOM.
	   * @type {?function(Array<!Node>)}
	   */
            nodesCreated: null,
            /**
	   * Called after patch has compleated with any Nodes that have been removed
	   * from the DOM.
	   * Note it's an applications responsibility to handle any childNodes.
	   * @type {?function(Array<!Node>)}
	   */
            nodesDeleted: null
        };
        /**
	 * @param {!Node} node
	 */
        Context.prototype.markCreated = function(node) {
            this.created && this.created.push(node);
        }, /**
	 * @param {!Node} node
	 */
        Context.prototype.markDeleted = function(node) {
            this.deleted && this.deleted.push(node);
        }, /**
	 * Notifies about nodes that were created during the patch opearation.
	 */
        Context.prototype.notifyChanges = function() {
            this.created && this.created.length > 0 && notifications.nodesCreated(this.created), 
            this.deleted && this.deleted.length > 0 && notifications.nodesDeleted(this.deleted);
        };
        /**
	* Makes sure that keyed Element matches the tag name provided.
	* @param {!string} nodeName The nodeName of the node that is being matched.
	* @param {string=} tag The tag name of the Element.
	* @param {?string=} key The key of the Element.
	*/
        var context = null, currentNode = null, currentParent = null, root = null, doc = null, patchFactory = function(run) {
            /**
	   * TODO(moz): These annotations won't be necessary once we switch to Closure
	   * Compiler's new type inference. Remove these once the switch is done.
	   *
	   * @param {(!Element|!DocumentFragment)} node
	   * @param {!function(T)} fn
	   * @param {T=} data
	   * @template T
	   */
            var f = function(node, fn, data) {
                var prevContext = context, prevRoot = root, prevDoc = doc, prevCurrentNode = currentNode, prevCurrentParent = currentParent;
                context = new Context(), root = node, doc = node.ownerDocument, currentParent = node.parentNode, 
                run(node, fn, data), context.notifyChanges(), context = prevContext, root = prevRoot, 
                doc = prevDoc, currentNode = prevCurrentNode, currentParent = prevCurrentParent;
            };
            return f;
        }, patchInner = patchFactory(function(node, fn, data) {
            currentNode = node, enterNode(), fn(data), exitNode();
        }), patchOuter = patchFactory(function(node, fn, data) {
            currentNode = /** @type {!Element} */ {
                nextSibling: node
            }, fn(data);
        }), matches = function(nodeName, key) {
            var data = getData(currentNode);
            // Key check is done using double equals as we want to treat a null key the
            // same as undefined. This should be okay as the only values allowed are
            // strings, null and undefined so the == semantics are not too weird.
            return nodeName === data.nodeName && key == data.key;
        }, alignWithDOM = function(nodeName, key, statics) {
            if (!currentNode || !matches(nodeName, key)) {
                var node = void 0;
                // Check to see if the node has moved within the parent.
                key && (node = getChild(currentParent, key)), // Create the node if it doesn't exist.
                node || (node = "#text" === nodeName ? createText(doc) : createElement(doc, currentParent, nodeName, key, statics), 
                key && registerChild(currentParent, key, node), context.markCreated(node)), // If the node has a key, remove it from the DOM to prevent a large number
                // of re-orders in the case that it moved far or was completely removed.
                // Since we hold on to a reference through the keyMap, we can always add it
                // back.
                currentNode && getData(currentNode).key ? (currentParent.replaceChild(node, currentNode), 
                getData(currentParent).keyMapValid = !1) : currentParent.insertBefore(node, currentNode), 
                currentNode = node;
            }
        }, clearUnvisitedDOM = function() {
            var node = currentParent, data = getData(node), keyMap = data.keyMap, keyMapValid = data.keyMapValid, child = node.lastChild, key = void 0;
            if (!(child === currentNode && keyMapValid || data.attrs[symbols.placeholder] && node !== root)) {
                for (;child !== currentNode; ) node.removeChild(child), context.markDeleted(/** @type {!Node}*/ child), 
                key = getData(child).key, key && delete keyMap[key], child = node.lastChild;
                // Clean the keyMap, removing any unusued keys.
                if (!keyMapValid) {
                    for (key in keyMap) child = keyMap[key], child.parentNode !== node && (context.markDeleted(child), 
                    delete keyMap[key]);
                    data.keyMapValid = !0;
                }
            }
        }, enterNode = function() {
            currentParent = currentNode, currentNode = null;
        }, nextNode = function() {
            currentNode = currentNode ? currentNode.nextSibling : currentParent.firstChild;
        }, exitNode = function() {
            clearUnvisitedDOM(), currentNode = currentParent, currentParent = currentParent.parentNode;
        }, coreElementOpen = function(tag, key, statics) {
            return nextNode(), alignWithDOM(tag, key, statics), enterNode(), currentParent;
        }, coreElementClose = function() {
            return exitNode(), currentNode;
        }, coreText = function() {
            return nextNode(), alignWithDOM("#text", null, null), currentNode;
        }, currentElement = function() {
            return currentParent;
        }, skip = function() {
            currentNode = currentParent.lastChild;
        }, ATTRIBUTES_OFFSET = 3, argsBuilder = [], elementOpen = function(tag, key, statics, const_args) {
            for (var node = coreElementOpen(tag, key, statics), data = getData(node), attrsArr = data.attrsArr, newAttrs = data.newAttrs, attrsChanged = !1, i = ATTRIBUTES_OFFSET, j = 0; i < arguments.length; i += 1, 
            j += 1) if (attrsArr[j] !== arguments[i]) {
                attrsChanged = !0;
                break;
            }
            for (;i < arguments.length; i += 1, j += 1) attrsArr[j] = arguments[i];
            /*
	   * Actually perform the attribute update.
	   */
            if (j < attrsArr.length && (attrsChanged = !0, attrsArr.length = j), attrsChanged) {
                for (i = ATTRIBUTES_OFFSET; i < arguments.length; i += 2) newAttrs[arguments[i]] = arguments[i + 1];
                for (var _attr in newAttrs) updateAttribute(node, _attr, newAttrs[_attr]), newAttrs[_attr] = void 0;
            }
            return node;
        }, elementOpenStart = function(tag, key, statics) {
            argsBuilder[0] = tag, argsBuilder[1] = key, argsBuilder[2] = statics;
        }, attr = function(name, value) {
            argsBuilder.push(name, value);
        }, elementOpenEnd = function() {
            var node = elementOpen.apply(null, argsBuilder);
            return argsBuilder.length = 0, node;
        }, elementClose = function(tag) {
            var node = coreElementClose();
            return node;
        }, elementVoid = function(tag, key, statics, const_args) {
            return elementOpen.apply(null, arguments), elementClose(tag);
        }, elementPlaceholder = function(tag, key, statics, const_args) {
            return elementOpen.apply(null, arguments), skip(), elementClose(tag);
        }, text = function(value, const_args) {
            var node = coreText(), data = getData(node);
            if (data.text !== value) {
                data.text = /** @type {string} */ value;
                for (var formatted = value, i = 1; i < arguments.length; i += 1) {
                    /*
	       * Call the formatter function directly to prevent leaking arguments.
	       * https://github.com/google/incremental-dom/pull/204#issuecomment-178223574
	       */
                    var fn = arguments[i];
                    formatted = fn(formatted);
                }
                node.data = formatted;
            }
            return node;
        };
        exports.patch = patchInner, exports.patchInner = patchInner, exports.patchOuter = patchOuter, 
        exports.currentElement = currentElement, exports.skip = skip, exports.elementVoid = elementVoid, 
        exports.elementOpenStart = elementOpenStart, exports.elementOpenEnd = elementOpenEnd, 
        exports.elementOpen = elementOpen, exports.elementClose = elementClose, exports.elementPlaceholder = elementPlaceholder, 
        exports.text = text, exports.attr = attr, exports.symbols = symbols, exports.attributes = attributes, 
        exports.applyAttr = applyAttr, exports.applyProp = applyProp, exports.notifications = notifications;
    }, /* 24 */
    /***/
    function(module, exports, __webpack_require__) {
        var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;
        /*!
	  Copyright (c) 2016 Jed Watson.
	  Licensed under the MIT License (MIT), see
	  http://jedwatson.github.io/classnames
	*/
        /* global define */
        !function() {
            "use strict";
            function classNames() {
                for (var classes = [], i = 0; i < arguments.length; i++) {
                    var arg = arguments[i];
                    if (arg) {
                        var argType = typeof arg;
                        if ("string" === argType || "number" === argType) classes.push(arg); else if (Array.isArray(arg)) classes.push(classNames.apply(null, arg)); else if ("object" === argType) for (var key in arg) hasOwn.call(arg, key) && arg[key] && classes.push(key);
                    }
                }
                return classes.join(" ");
            }
            var hasOwn = {}.hasOwnProperty;
            "undefined" != typeof module && module.exports ? module.exports = classNames : (__WEBPACK_AMD_DEFINE_ARRAY__ = [], 
            __WEBPACK_AMD_DEFINE_RESULT__ = function() {
                return classNames;
            }.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__), // register as 'classnames', consistent with npm package name
            !(void 0 !== __WEBPACK_AMD_DEFINE_RESULT__ && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)));
        }();
    }, /* 25 */
    /***/
    function(module, exports, __webpack_require__) {
        exports = module.exports = __webpack_require__(26)(), // imports
        // module
        exports.push([ module.id, "._1W1Nqrropv0xHevXc01L9b{bottom:0;left:0;position:fixed;right:0;top:0}._2jkUido-eka0FjtgtzHfhf{background:#091e42;opacity:.5}._3VEYBf7FbiuSuQ4zaBNSF9,ak-blanket{display:block}._3VEYBf7FbiuSuQ4zaBNSF9:not([defined]),ak-blanket:not([defined]){display:none}:host{display:block}:host(:not([defined])){display:none}", "" ]), 
        // exports
        exports.locals = {
            blanket: "_1W1Nqrropv0xHevXc01L9b",
            blanket: "_1W1Nqrropv0xHevXc01L9b",
            tinted: "_2jkUido-eka0FjtgtzHfhf",
            tinted: "_2jkUido-eka0FjtgtzHfhf",
            "ak-blanket": "_3VEYBf7FbiuSuQ4zaBNSF9",
            akBlanket: "_3VEYBf7FbiuSuQ4zaBNSF9"
        };
    }, /* 26 */
    /***/
    function(module, exports) {
        /*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
        // css base code, injected by the css-loader
        module.exports = function() {
            var list = [];
            // return the list of modules as css string
            // import a list of modules into the list
            return list.toString = function() {
                for (var result = [], i = 0; i < this.length; i++) {
                    var item = this[i];
                    item[2] ? result.push("@media " + item[2] + "{" + item[1] + "}") : result.push(item[1]);
                }
                return result.join("");
            }, list.i = function(modules, mediaQuery) {
                "string" == typeof modules && (modules = [ [ null, modules, "" ] ]);
                for (var alreadyImportedModules = {}, i = 0; i < this.length; i++) {
                    var id = this[i][0];
                    "number" == typeof id && (alreadyImportedModules[id] = !0);
                }
                for (i = 0; i < modules.length; i++) {
                    var item = modules[i];
                    // skip already imported module
                    // this implementation is not 100% perfect for weird media query combinations
                    //  when a module is imported multiple times with different media queries.
                    //  I hope this will never occur (Hey this way we have smaller bundles)
                    "number" == typeof item[0] && alreadyImportedModules[item[0]] || (mediaQuery && !item[2] ? item[2] = mediaQuery : mediaQuery && (item[2] = "(" + item[2] + ") and (" + mediaQuery + ")"), 
                    list.push(item));
                }
            }, list;
        };
    }, /* 27 */
    /***/
    function(module, exports) {
        "use strict";
        Object.defineProperty(exports, "__esModule", {
            value: !0
        });
        /**
	* This event is emitted when the blanket is clicked.
	* The emission of this event can be controlled by the {@link Blanket#clickable} property.
	*
	* @event Blanket#activate
	*/
        // eslint-disable-next-line import/prefer-default-export
        exports.activate = "activate";
    } ]);
});